// RankingDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "CrystalCPUID.h"
#include "RankingDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define USER_AGENT "CrystalCPUID"
/*
#define LOCAL

#ifdef LOCAL
#define SERVER_NAME "localhost"
#define SCRIPT_PATH "/CrystalCPUID/09/regist.php"
#define RANKING_STR	"http://localhost/CrystalCPUID/09/ranking.php?ID=%d"
#endif 
*/

#ifndef LOCAL
#define SERVER_NAME "chup.ec.hokudai.ac.jp"
#define SCRIPT_PATH "/~hiyohiyo/CrystalCPUID/10/regist.php"
#define RANKING_STR	"http://chup.ec.hokudai.ac.jp/~hiyohiyo/CrystalCPUID/10/ranking.php?ID=%d"
#endif

/////////////////////////////////////////////////////////////////////////////
// CRankingDlg _CAO


CRankingDlg::CRankingDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRankingDlg::IDD, pParent)
{
//	SysInfo = ((CCrystalCPUIDDlg *)pParent)->SysInfo;
	Parent = (CCrystalCPUIDDlg *)pParent;
	//{{AFX_DATA_INIT(CRankingDlg)
	m_UserName = _T("");
	m_SystemClock = _T("");
	m_Multiplier = _T("");
	m_Mother = _T("");
	m_Memory = _T("");
	m_Mail = _T("");
	m_VIO = _T("");
	m_Homepage = _T("");
	m_VCore = _T("");
	m_Cool = _T("");
	m_Comment = _T("");
	m_Clock = _T("");
	m_ChipSet = _T("");
	m_CPUName = _T("");
	m_ClockOri = _T("");
	m_MultiplierOri = _T("");
	m_SystemClockOri = _T("");
	m_OverClock = _T("");
	m_Area = _T("");
	m_Password = _T("");
	m_Machine = _T("");
	m_OS = _T("");
	//}}AFX_DATA_INIT

}


void CRankingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRankingDlg)
	DDX_Control(pDX, IDC_CPU_CPU, m_CPUNameC);
	DDX_Control(pDX, IDC_AREA, m_AreaC);
	DDX_Control(pDX, IDC_MULTIPLIER, m_MultiplierC);
	DDX_Control(pDX, IDC_FIX, m_Fix);
	DDX_Control(pDX, IDC_CLOCK_ORI, m_ClockOriC);
	DDX_Control(pDX, IDC_SYSTEM_CLOCK_ORI, m_SystemClockOriC);
	DDX_Control(pDX, IDC_MULTIPLIER_ORI, m_MultiplierOriC);
	DDX_Text(pDX, IDC_USER_NAME, m_UserName);
	DDV_MaxChars(pDX, m_UserName, 32);
	DDX_Text(pDX, IDC_SYSTEM_CLOCK, m_SystemClock);
	DDV_MaxChars(pDX, m_SystemClock, 8);
	DDX_Text(pDX, IDC_MULTIPLIER, m_Multiplier);
	DDV_MaxChars(pDX, m_Multiplier, 8);
	DDX_Text(pDX, IDC_MOTHER, m_Mother);
	DDV_MaxChars(pDX, m_Mother, 64);
	DDX_Text(pDX, IDC_MEMORY, m_Memory);
	DDV_MaxChars(pDX, m_Memory, 50);
	DDX_Text(pDX, IDC_MAIL, m_Mail);
	DDV_MaxChars(pDX, m_Mail, 128);
	DDX_Text(pDX, IDC_IO_VOLTAGE, m_VIO);
	DDV_MaxChars(pDX, m_VIO, 8);
	DDX_Text(pDX, IDC_HOMEPAGE, m_Homepage);
	DDV_MaxChars(pDX, m_Homepage, 128);
	DDX_Text(pDX, IDC_CORE_VOLTAGE, m_VCore);
	DDV_MaxChars(pDX, m_VCore, 8);
	DDX_Text(pDX, IDC_COOL, m_Cool);
	DDV_MaxChars(pDX, m_Cool, 50);
	DDX_Text(pDX, IDC_COMMENT, m_Comment);
	DDV_MaxChars(pDX, m_Comment, 200);
	DDX_Text(pDX, IDC_CLOCK, m_Clock);
	DDV_MaxChars(pDX, m_Clock, 8);
	DDX_Text(pDX, IDC_CHIP_SET, m_ChipSet);
	DDX_Text(pDX, IDC_CPU, m_CPUName);
	DDV_MaxChars(pDX, m_CPUName, 64);
	DDX_Text(pDX, IDC_CLOCK_ORI, m_ClockOri);
	DDV_MaxChars(pDX, m_ClockOri, 8);
	DDX_Text(pDX, IDC_MULTIPLIER_ORI, m_MultiplierOri);
	DDV_MaxChars(pDX, m_MultiplierOri, 8);
	DDX_Text(pDX, IDC_SYSTEM_CLOCK_ORI, m_SystemClockOri);
	DDV_MaxChars(pDX, m_SystemClockOri, 8);
	DDX_Text(pDX, IDC_OVER_CLOCK, m_OverClock);
	DDV_MaxChars(pDX, m_OverClock, 8);
	DDX_CBString(pDX, IDC_AREA, m_Area);
	DDV_MaxChars(pDX, m_Area, 16);
	DDX_Text(pDX, IDC_PASSWORD, m_Password);
	DDV_MaxChars(pDX, m_Password, 8);
	DDX_Text(pDX, IDC_MACHINE, m_Machine);
	DDV_MaxChars(pDX, m_Machine, 32);
	DDX_Text(pDX, IDC_OS, m_OS);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRankingDlg, CDialog)
	//{{AFX_MSG_MAP(CRankingDlg)
	ON_BN_CLICKED(IDC_FIX, OnFix)
	ON_EN_CHANGE(IDC_SYSTEM_CLOCK_ORI, OnChangeSystemClockOri)
	ON_EN_CHANGE(IDC_MULTIPLIER_ORI, OnChangeMultiplierOri)
	ON_EN_CHANGE(IDC_MULTIPLIER, OnChangeMultiplier)
	ON_BN_CLICKED(IDC_AFTER, OnAfter)
	ON_NOTIFY_EX( TTN_NEEDTEXT, 0, OnToolTipNotify )
	ON_BN_CLICKED(IDC_ENTRY, OnEntry)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRankingDlg bZ[W nh

static void AddPostDataS(CString& post,CString label,CString m);
static void AddPostDataF(CString& post,CString label,CString f);
static void AddPostDataI(CString& post,CString label,CString i);
static void AddPostDataX(CString& post,CString label,CString x);

BOOL CRankingDlg::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
	TOOLTIPTEXT *pTTT = (TOOLTIPTEXT *)pNMHDR;
    UINT nID =pNMHDR->idFrom;
    if (pTTT->uFlags & TTF_IDISHWND)
    {
        // idFrom is actually the HWND of the tool
        nID = ::GetDlgCtrlID((HWND)nID);
        if(nID)
        {
            pTTT->lpszText = MAKEINTRESOURCE(nID);
            pTTT->hinst = AfxGetResourceHandle();
            return(TRUE);
        }
    }
    return(FALSE);
}

static void AddPostDataS(CString& post,CString label,CString m)
{
	CString cstr;
	m.Replace("&","%26");
	m.Replace("=","%3D");

	cstr.Format("%s=%s&",label,m);
	post += cstr;
}

static void AddPostDataI(CString& post,CString label,CString i)
{
	CString cstr;
	int j = atoi(i);
	if(j < 0){
		j = -1;
	}
	cstr.Format("%s=%d&",label,j);
	post += cstr;
}

static void AddPostDataX(CString& post,CString label,CString x)
{
	CString cstr;
	cstr = "0x" + x;
	int j = strtol(cstr,NULL,16);
	if(j <= 0){
		j = 0;
	}
	cstr.Format("%s=%d&",label,j);
	post += cstr;
}

static void AddPostDataF(CString& post,CString label,CString f)
{
	CString cstr;

	cstr.Format("%s=%.2f&",label,atof(f));
	post += cstr;
}

BOOL CRankingDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CString cstr;
	char str[256];

	//  //
	m_Clock = Parent->m_Clock;
	m_SystemClock = Parent->m_SystemClock;
	m_Multiplier = Parent->m_Multiplier;
	m_ClockOri = Parent->m_ClockOri;
	m_OverClock = Parent->m_OverClock;

	m_SystemClockOri = Parent->m_SystemClockOri;
	m_MultiplierOri = Parent->m_MultiplierOri;

// ߋƂ̌݊̂߂ނ𓾂... 2003/3/5
	Parent->ConnectSysInfo(MODE_CPU);
	SysInfo = Parent->SysInfo;
	SysInfo->GetString(CPU_NAME_SYS_INFO,str);	
	m_CPUName = str;
	Parent->DisconnectSysInfo();

	CString OSName,OSType,OSCSD,OSVersion,OSBuild,OSInfo;
	GetOSInfo(OSName,OSType,OSCSD,OSVersion,OSBuild,OSInfo);
	m_OS = OSName + " " + OSCSD;

//	SysInfo->GetString(PCI_CHIP_SET_NAME_SI,str);
//	m_ChipSet = str;

//	m_CPUName = AfxGetApp()->GetProfileString("Setting","CPUName");
//	m_ChipSet = AfxGetApp()->GetProfileString("Setting","ChipSet");
	m_UserName = AfxGetApp()->GetProfileString("Setting","UserName");
	m_Machine = AfxGetApp()->GetProfileString("Setting","Machine");
	m_Area = AfxGetApp()->GetProfileString("Setting","Area");
	m_Mail = AfxGetApp()->GetProfileString("Setting","Mail");
	m_Homepage = AfxGetApp()->GetProfileString("Setting","Homepage");
	m_VCore = AfxGetApp()->GetProfileString("Setting","VCore");
	m_VIO = AfxGetApp()->GetProfileString("Setting","VIO");
	m_Mother = AfxGetApp()->GetProfileString("Setting","Mother");
	m_Memory = AfxGetApp()->GetProfileString("Setting","Memory");
	m_Cool = AfxGetApp()->GetProfileString("Setting","Cool");
	m_Comment = AfxGetApp()->GetProfileString("Setting","Comment");
	m_Password = AfxGetApp()->GetProfileString("Setting","Password");

	UpdateData(FALSE);
	if(! Parent->m_FlagEnglish){
		EnableToolTips(TRUE);
	}
	return TRUE;
}

void CRankingDlg::OnFix() 
{
	if(! Parent->m_FlagEnglish){
		MessageBox("Fꍇ݂̂p\r\n\r\n@@@R\@@_@@΁@");
	}else{
		MessageBox("You should input true infomation.");
	}
	m_CPUNameC.SetReadOnly(FALSE);
	m_SystemClockOriC.SetReadOnly(FALSE);
	m_MultiplierOriC.SetReadOnly(FALSE);
	m_MultiplierC.SetReadOnly(FALSE);
	m_Fix.EnableWindow(FALSE);
}

void CRankingDlg::OnChangeSystemClockOri() 
{
	UpdateData(TRUE);
	if(atof(m_SystemClockOri) > 0.0 && atof(m_MultiplierOri) >= 1.0){
		m_ClockOri.Format("%.2f",atof(m_SystemClockOri) * atof(m_MultiplierOri) );
		m_OverClock.Format("%.2f",atof(m_Clock) / atof(m_ClockOri) * 100.0 - 100.0);
	}
	UpdateData(FALSE);
}

void CRankingDlg::OnChangeMultiplierOri() 
{
	UpdateData(TRUE);
	if(atof(m_SystemClockOri) > 0.0 && atof(m_MultiplierOri) >= 1.0){
		m_ClockOri.Format("%.2f",atof(m_SystemClockOri) * atof(m_MultiplierOri) );
		m_OverClock.Format("%.2f",atof(m_Clock) / atof(m_ClockOri) * 100.0 - 100.0);
	}
	UpdateData(FALSE);
}

void CRankingDlg::OnChangeMultiplier() 
{
	UpdateData(TRUE);
	if(atof(m_Multiplier) >= 1.0 && atof(m_Clock) > 0.0){
		m_SystemClock.Format("%.2f",atof(m_Clock) / atof(m_Multiplier) );
	}
	UpdateData(FALSE);
}

void CRankingDlg::OnAfter() 
{
	UpdateData(TRUE);

	// INI t@Cɐݒۑ...
	AfxGetApp()->WriteProfileString("Setting","UserName",m_UserName);
	AfxGetApp()->WriteProfileString("Setting","Machine",m_Machine);
	AfxGetApp()->WriteProfileString("Setting","Area",m_Area);
	AfxGetApp()->WriteProfileString("Setting","Mail",m_Mail);
	AfxGetApp()->WriteProfileString("Setting","Homepage",m_Homepage);
	AfxGetApp()->WriteProfileString("Setting","CPU Name",m_CPUName);
	AfxGetApp()->WriteProfileString("Setting","VCore",m_VCore);
	AfxGetApp()->WriteProfileString("Setting","VIO",m_VIO);
	AfxGetApp()->WriteProfileString("Setting","Mother",m_Mother);
	AfxGetApp()->WriteProfileString("Setting","ChipSet",m_ChipSet);
	AfxGetApp()->WriteProfileString("Setting","Memory",m_Memory);
	AfxGetApp()->WriteProfileString("Setting","Cool",m_Cool);
	AfxGetApp()->WriteProfileString("Setting","Comment",m_Comment);
	AfxGetApp()->WriteProfileString("Setting","Password",m_Password);

	OnCancel();	
}

BOOL CRankingDlg::OnEntry() 
{
	UpdateData(TRUE);

	if(	m_UserName.IsEmpty() || m_CPUName.IsEmpty() || m_Machine.IsEmpty()
		|| m_Cool.IsEmpty()	||  m_Comment.IsEmpty() || m_Area.IsEmpty())
	{
		if(! Parent->m_FlagEnglish){
			MessageBox("K{͂Ă܂");
		}else{
			MessageBox("Please input essensial infomation.");
		}
		return FALSE;
	}

	if(! ( atof(m_Clock) > 0.0 && atof(m_ClockOri) > 0.0
		&& atof(m_SystemClock) > 0.0 && atof(m_SystemClockOri) > 0.0 
		&& atof(m_Multiplier) > 0.0 && atof(m_MultiplierOri) > 0.0 ) )
	{
		if(! Parent->m_FlagEnglish){
			MessageBox("NbNg̏͐mɓ͂Ă");
		}else{
			MessageBox("Clock Infomation is unsuitable.");
		}
		return FALSE;
	}

	if(! (atof(m_OverClock) > 1.0 ) )
	{
		if(! Parent->m_FlagEnglish){
			MessageBox("I[o[NbNĂȂf[^̓o^͂ł܂");
		}else{
			MessageBox("This Contest is OverClocker's ONLY.");
		}
		return FALSE;
	}

	CString post;
	CString cstr;

	AddPostDataS(post,"UserName",m_UserName);
	AddPostDataS(post,"Machine",m_Machine);
	AddPostDataS(post,"Area",m_Area);
	AddPostDataS(post,"Mail",m_Mail);
	AddPostDataS(post,"Homepage",m_Homepage);
	AddPostDataS(post,"CPUName",m_CPUName);
	AddPostDataS(post,"OS",m_OS);
	AddPostDataS(post,"Mother",m_Mother);
	AddPostDataS(post,"ChipSet",m_ChipSet);
	AddPostDataS(post,"Memory",m_Memory);
	AddPostDataS(post,"Cool",m_Cool);
	AddPostDataS(post,"Comment",m_Comment);
	AddPostDataS(post,"Password",m_Password);

	AddPostDataF(post,"Clock",m_Clock);
	AddPostDataF(post,"ClockOri",m_ClockOri);
	AddPostDataF(post,"SystemClock",m_SystemClock);
	AddPostDataF(post,"SystemClockOri",m_SystemClockOri);
	AddPostDataF(post,"Multiplier",m_Multiplier);
	AddPostDataF(post,"MultiplierOri",m_MultiplierOri);
	AddPostDataF(post,"OverClock",m_OverClock);
	AddPostDataF(post,"VCore",m_VCore);
	AddPostDataF(post,"VIO",m_VIO);

	AddPostDataS(post,"NameString",Parent->m_NameString);
	AddPostDataX(post,"BrandID",Parent->m_BrandID);
	AddPostDataS(post,"VendorString",Parent->m_VendorString);

	AddPostDataX(post,"Family",Parent->m_Family);
	AddPostDataX(post,"FamilyEx",Parent->m_FamilyEx);
	AddPostDataX(post,"Model",Parent->m_Model);
	AddPostDataX(post,"Stepping",Parent->m_Stepping);
	AddPostDataI(post,"CPUNumber",Parent->m_CPUNumber);
	AddPostDataI(post,"HyperThreadNum",Parent->m_CPUNumber);
	AddPostDataI(post,"L2Cache",Parent->m_L2Cache);

	char *token;
	char buf[32];
	strcpy(buf,Parent->CrystalCPUIDVersion);
	token = strtok( buf , "." );cstr.Format("Major=%s",token);post += ( cstr + "&" );
	token = strtok( NULL, "." );cstr.Format("Minor=%s",token);post += ( cstr + "&" );
	token = strtok( NULL, "." );cstr.Format("Revision=%s",token);post += ( cstr + "&" );
	token = strtok( NULL, "." );cstr.Format("Release=%s",token);post += ( cstr + "&" );

	post += "check=1";

	int result = 0;
	result = HttpPostMethod((LPSTR)(LPCTSTR)post,SERVER_NAME,SCRIPT_PATH,USER_AGENT);

	if(result > 0){
		cstr.Format(RANKING_STR,result);
		ShellExecute(m_hWnd,"open",cstr,NULL,NULL,SW_SHOWNORMAL);
	}else if(result == ERROR_HTTP_OFF_LINE || result == 0){
		if(! Parent->m_FlagEnglish){
			if(MessageBox(
				"Web œo^s߂ɕKvȃf[^Nbv{[hɃRs[܂H\r\no^ CrystalCPUID OverClocker's Ranking ́uo^vR[i[s܂B",
				"CrystalCPUID OverClocker's Ranking",MB_YESNO) == IDYES)
			{
				CString clip = post;
				if(OpenClipboard())
				{
					HGLOBAL clipbuffer;
					char * buffer;
					EmptyClipboard();
					clipbuffer = GlobalAlloc(GMEM_DDESHARE, clip.GetLength()+1);
					buffer = (char*)GlobalLock(clipbuffer);
					strcpy(buffer, LPCSTR(clip));
					GlobalUnlock(clipbuffer);
					SetClipboardData(CF_TEXT,clipbuffer);
					CloseClipboard();
				}
			}
		}else{
			MessageBox("HTTP Server is down now.");
		}
	}else if(result == ERROR_HTTP_SAME_DATA){
		if(! Parent->m_FlagEnglish){
			MessageBox("dê悤łB");
		}else{
			MessageBox("Already registed.");
		}
	}else if(result == ERROR_HTTP_SAME_MACHINE){
		if(! Parent->m_FlagEnglish){
			MessageBox("}Vŕo^ꍇ͕KRgɉǂႤ̂LĂB");
		}else{
			MessageBox("Already registed.");
		}
	}
	
	return TRUE;
}
