#ifndef __SYSINFO_SHARE_H__
#define __SYSINFO_SHARE_H__

#include <windows.h>
#include <wininet.h>
#include "../CrystalMarkShare/ItemID.h"

#define ERROR_HTTP_OFF_LINE			-32768
#define ERROR_HTTP_SAME_DATA			-1
#define ERROR_HTTP_SAME_MACHINE			-5

void WindowFlash(CWnd& Wnd);
BOOL IsPC98();
DWORD CheckSafeMode();
int CheckWMIFlag(const char* check);
void DeviceNameList(char* FileName,CComboBox& combo);
void LoadDataBase(CString FileName,CComboBox& ComboBox);
void ChipSetList(char* FileName,CComboBox& combo);
void GetOSInfo(CString& OSName,CString& OSType,CString& OSCSD,CString& OSVersion,CString& OSBuild,CString& OSInfo);
int ExecAndWait(char *pszCmd, BOOL bNoWindow);
int HttpPostMethod(char* post,char *ServerName,char *ScriptPath,char *UserAgent);
double GetFileVersion(char *file,int *major = NULL,int *minor = NULL,int *revision = NULL,int *build = NULL,char *ver = NULL);
void ExecuteFile(char* FileName);
int FontSetting();
void GetFontStatus(CString& cstr);
void DebugInfo(char* mes);
BOOL SetAlphaWindow(HWND& hWnd,unsigned char alpha);
BOOL IsWinNT();
void GetDisplayMode(int& width,int& height,int& color,int& font);

typedef HINTERNET(WINAPI * _InternetOpen_)(
	IN LPCSTR lpszAgent,
    IN DWORD dwAccessType,
    IN LPCSTR lpszProxyName,
    IN LPCSTR lpszProxyBypass,
    IN DWORD dwFlags
);

typedef HINTERNET(WINAPI * _InternetConnect_)(
    IN HINTERNET hInternetSession,
    IN LPCSTR lpszServerName,
    IN INTERNET_PORT nServerPort,
    IN LPCSTR lpszUsername,
    IN LPCSTR lpszPassword,
    IN DWORD dwService,
    IN DWORD dwFlags,
    IN DWORD dwContext
);

typedef HINTERNET(WINAPI * _HttpOpenRequest_)(
    IN HINTERNET hHttpSession,
    IN LPCSTR lpszVerb,
    IN LPCSTR lpszObjectName,
    IN LPCSTR lpszVersion,
    IN LPCSTR lpszReferer,
    IN LPCSTR FAR * lpszAcceptTypes,
    IN DWORD dwFlags,
    IN DWORD dwContext
);

typedef BOOL(WINAPI * _HttpSendRequest_)(
    IN HINTERNET hHttpRequest,
    IN LPCSTR lpszHeaders,
    IN DWORD dwHeadersLength,
    IN LPVOID lpOptional,
    DWORD dwOptionalLength
);

typedef BOOL(WINAPI * _HttpQueryInfo_)(
    IN HINTERNET hHttpRequest,
    IN DWORD dwInfoLevel,
    IN LPVOID lpvBuffer,
    IN LPDWORD lpdwBufferLength,
    IN OUT LPDWORD lpdwIndex
);

typedef BOOL(WINAPI * _InternetCloseHandle_)(
    IN HINTERNET hInet
);

typedef BOOL(WINAPI * _InternetCanonicalizeUrl_)(
    IN LPCSTR lpszUrl,
    OUT LPSTR lpszBuffer,
    IN OUT LPDWORD lpdwBufferLength,
    IN DWORD dwFlags
);

#endif